"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _lodash = _interopRequireDefault(require("lodash"));

var _flattenColorPalette = _interopRequireDefault(require("../util/flattenColorPalette"));

var _withAlphaVariable = _interopRequireDefault(require("../util/withAlphaVariable"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _default() {
  return function ({
    addUtilities,
    e,
    theme,
    variants,
    target,
    corePlugins
  }) {
    if (target('borderColor') === 'ie11') {
      const colors = (0, _flattenColorPalette.default)(theme('borderColor'));

      const utilities = _lodash.default.fromPairs(_lodash.default.map(_lodash.default.omit(colors, 'default'), (value, modifier) => {
        return [`.${e(`border-${modifier}`)}`, {
          'border-color': value
        }];
      }));

      addUtilities(utilities, variants('borderColor'));
      return;
    }

    const colors = (0, _flattenColorPalette.default)(theme('borderColor'));

    const utilities = _lodash.default.fromPairs(_lodash.default.map(_lodash.default.omit(colors, 'default'), (value, modifier) => {
      return [`.${e(`border-${modifier}`)}`, corePlugins('borderOpacity') ? (0, _withAlphaVariable.default)({
        color: value,
        property: 'border-color',
        variable: '--border-opacity'
      }) : {
        'border-color': value
      }];
    }));

    addUtilities(utilities, variants('borderColor'));
  };
}